ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.81
Committed: Sat Apr 3 03:13:48 2010 UTC (14 years, 1 month ago) by root
Branch: MAIN
Changes since 1.80: +1 -1 lines
Log Message:
details

File Contents

# Content
1 #!@PERL@
2
3 #
4 # This file is part of Deliantra, the Roguelike Realtime MMORPG.
5 #
6 # Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7 #
8 # Deliantra is free software: you can redistribute it and/or modify it under
9 # the terms of the Affero GNU General Public License as published by the
10 # Free Software Foundation, either version 3 of the License, or (at your
11 # option) any later version.
12 #
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the Affero GNU General Public License
19 # and the GNU General Public License along with this program. If not, see
20 # <http://www.gnu.org/licenses/>.
21 #
22 # The authors can be reached via e-mail to <support@deliantra.net>
23 #
24
25 use strict;
26
27 my $prefix = "@prefix@";
28 my $exec_prefix = "@exec_prefix@";
29 my $datarootdir = "@datarootdir@";
30 my $DATADIR = "@datadir@/@PACKAGE@";
31
32 my $CONVERT = "@CONVERT@";
33 #my $IDENTIFY = "@IDENTIFY@";
34 my $OPTIPNG = "@OPTIPNG@";
35 my $RSYNC = "@RSYNC@";
36 my $PNGNQ = "@PNGNQ@";
37
38 use Getopt::Long;
39 use File::Temp;
40 use POSIX ();
41 use Carp;
42
43 use Coro::EV;
44 use AnyEvent;
45 use YAML::XS ();
46 use JSON::XS ();
47 use IO::AIO ();
48 use Digest::MD5 ();
49
50 use Coro 5.12;
51 use Coro::AIO;
52 use Coro::Util;
53 use Coro::Channel;
54 use Coro::Storable; $Storable::canonical = 1;
55
56 use Deliantra;
57
58 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
59
60 sub usage {
61 warn <<EOF;
62 Usage: cfutil [-v] [-q] [--force] [--cache]
63 [--install-arch path]
64 [--install-maps maps]
65 [--print-statedir]
66 [--print-confdir]
67 [--print-datadir]
68 [--print-libdir]
69 [--print-bindir]
70 EOF
71 exit 1;
72 }
73
74 my $VERBOSE = 1;
75 my $CACHE = 0;
76 my $FORCE;
77 my $TMPDIR = "/tmp/cfutil$$~";
78 my $TMPFILE = "aaaa0";
79
80 our %COLOR = (
81 black => 0,
82 white => 1,
83 navy => 2,
84 red => 3,
85 orange => 4,
86 blue => 5,
87 darkorange => 6,
88 green => 7,
89 lightgreen => 8,
90 grey => 9,
91 brown => 10,
92 gold => 11,
93 tan => 12,
94 );
95
96 END { system "rm", "-rf", $TMPDIR }
97
98 my $s_INT = EV::signal INT => sub { exit 1 };
99 my $s_TERM = EV::signal TERM => sub { exit 1 };
100
101 our %hash;
102
103 # here we could try to avoid collisions and reduce chksum size further
104 sub make_hash($\$\$;$) {
105 my ($id, $dataref, $hashref, $clen) = @_;
106
107 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
108
109 if (exists $hash{$hash}) {
110 # hahs collinion, but some files are simply identical
111 if (${$hash{$hash}[1]} ne $$dataref) {
112 warn "hash collision $hash{$hash}[0] vs. $id\n";
113 exit 1;
114 } else {
115 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
116 }
117 }
118 $hash{$hash} = [$id, $dataref, $hashref];
119
120 $$hashref = $hash;
121 }
122
123 mkdir $TMPDIR, 0700
124 or die "$TMPDIR: $!";
125
126 sub fork_sub(&) {
127 my ($cb) = @_;
128
129 if (my $pid = fork) {
130 my $current = $Coro::current;
131 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
132 Coro::schedule;
133 } else {
134 eval { $cb->() };
135 POSIX::_exit 0 unless $@;
136 warn $@;
137 POSIX::_exit 1;
138 }
139 }
140
141 sub inst_maps($) {
142 my (undef, $path) = @_;
143
144 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
145
146 if (!-f "$path/regions") {
147 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
148 exit 1 unless $FORCE;
149 }
150
151 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
152 "$path/.", "$DATADIR/maps/.",
153 "--exclude", "CVS", "--exclude", "/world-precomposed",
154 "--delete", "--delete-excluded"
155 and die "map installation failed.\n";
156
157 print "maps installed successfully.\n";
158 }
159
160 {
161 our %ANIMINFO;
162 our %FACEINFO;
163 our %RESOURCE;
164 our @ARC;
165 our %ARC;
166 our $TRS;
167 our $NFILE;
168 our $PATH;
169
170 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
171
172 our $c_arc = new Coro::Channel;
173 our $c_trs = new Coro::Channel;
174 our $c_res = new Coro::Channel;
175
176 our @c_png;
177
178 sub commit_png($$$) {
179 my ($name, $data, $T) = @_;
180
181 $FACEINFO{$name}{"data$T"} = $data;
182 }
183
184 sub process_png {
185 while (@c_png) {
186 my ($path, $delete) = @{pop @c_png};
187
188 my $png;
189 aio_lstat $path;
190 my ($size, $mtime) = (stat _)[7,9];
191
192 if (0 > aio_load $path, $png) {
193 warn "$path: $!, skipping.\n";
194 next;
195 }
196
197 my $stem = $path;
198 my $T;
199
200 if ($stem =~ s/\.32x32\.png~?$//) {
201 $T = 32;
202 } elsif ($stem =~ s/\.64x64\.png~?$//) {
203 $T = 64;
204 } else {
205 warn "$path: weird filename, skipping.\n";
206 next;
207 }
208
209 # quickly extract width and height of the (necessarily PNG) image
210 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
211 warn "$path: not a recognized png file, skipping.\n";
212 next;
213 }
214
215 my ($w, $h) = unpack "NN", $1;
216
217 if ($w < $T || $h < $T) {
218 warn "$path: too small ($w $h), skipping.\n";
219 next;
220 }
221
222 if ($w % $T || $h % $T) {
223 warn "$path: weird png size ($w $h), skipping.\n";
224 next;
225 }
226
227 (my $base = $stem) =~ s/^.*\///;
228
229 my $fi = $FACEINFO{$base};
230 unless ($fi) {
231 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
232 #next;
233 }
234
235 my $arc = $fi->{arc} || { };
236
237 unless ($path =~ /~$/) {
238 # possibly enlarge
239 if (0 > aio_stat "$stem.64x64.png") {
240 my $other = "$stem.64x64.png~";
241
242 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
243 fork_sub {
244 my $CROP;
245 my $SRC = "png:\Q$path\E";
246
247 my $is_floor = $arc->{is_floor};
248 my $is_wall = 0;
249
250 my ($wall_pfx, $wall_dir, $wall_sfx);
251
252 if (
253 !$is_floor
254 && !$arc->{alive}
255 && $arc->{move_block} eq "all"
256 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
257 ) {
258 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
259
260 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
261 $is_wall = 1;
262 }
263 }
264
265 if ($is_wall || $is_floor) {
266 # add a 4px border and add other images around it
267 $CROP = "-shave 8x8 +repage";
268
269 $w += 8;
270 $h += 8;
271
272 $SRC = "-size ${w}x${h} xc:transparent";
273 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
274
275 # 8 surrounding images
276 for (
277 # x y b r0 r1
278 [-1, -1, 0, 6],
279 [ 0, -1, 1, 10, 14],
280 [+1, -1, 0, 12],
281
282 [-1, 0, 8, 5, 7],
283 #
284 [+1, 0, 2, 5, 13],
285
286 [-1, +1, 0, 3],
287 [ 0, +1, 4, 10, 11],
288 [+1, +1, 0, 9],
289 ) {
290 my ($x, $y, $d, $r0, $r1) = @$_;
291
292 my $tile = $is_floor ? $path
293 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
294 : die;
295
296 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
297 "\Q$tile",
298 $x * ($w - 8) + 4,
299 $y * ($h - 8) + 4;
300 }
301 }
302
303 system "convert -depth 8 $SRC rgba:-"
304 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
305 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
306 and die "convert/cfhq2xa pipeline error: status $? ($!)";
307 system $OPTIPNG, "-i0", "-q", "$other~";
308 die "$other~ has zero size, aborting." unless -s "$other~";
309 rename "$other~", $other;
310 };
311 }
312
313 push @c_png, [$other, !$CACHE];
314 }
315
316 # possibly scale down
317 if (0 > aio_stat "$stem.32x32.png") {
318 my $other = "$stem.32x32.png~";
319
320 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
321 fork_sub {
322 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
323 system $OPTIPNG, "-i0", "-q", "$other~";
324
325 # reduce smoothfaces >10000 bytes
326 # obsolete, no longer required
327 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
328 my $ncolor = 256;
329 while () {
330 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
331 system $OPTIPNG, "-i0", "-q", "$other~~";
332 last if 10000 > -s "$other~~";
333 $ncolor = int $ncolor * 0.9;
334 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
335 }
336
337 printf "reduced %s from %d to %d bytes using %d colours.\n",
338 $other, -s "$other~", -s "$other~~", $ncolor
339 if $VERBOSE >= 2;
340 rename "$other~~", "$other~";
341 }
342
343 die "$other~ has zero size, aborting." unless -s "$other~";
344 rename "$other~", $other;
345 };
346 }
347
348 #warn "scaled down $path to $other\n";#d#
349 push @c_png, [$other, !$CACHE];
350 }
351 }
352
353 (my $face = $stem) =~ s/^.*\///;
354
355 # split all bigfaces, but avoid smoothfaces (*_S)
356 if (($w > $T || $h > $T) && $face !~ /_S\./) {
357 # split
358 my @tile;
359 for my $x (0 .. (int $w / $T) - 1) {
360 for my $y (0 .. (int $h / $T) - 1) {
361 my $file = "$path+$x+$y~";
362 aio_lstat $file;
363 push @tile, [$x, $y, $file, (stat _)[9]];
364 }
365 }
366
367 my $mtime = (lstat $path)[9];
368 my @todo = grep { $_->[3] <= $mtime } @tile;
369 if (@todo) {
370 fork_sub {
371 open my $convert, "|-", $CONVERT,
372 "png:-",
373 (map {
374 (
375 "(",
376 "+clone",
377 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
378 "+repage",
379 -quality => "00",
380 -write => "png32:$_->[2]~",
381 "+delete",
382 ")",
383 )
384 } @todo),
385 "null:";
386
387 binmode $convert;
388 print $convert $png;
389 close $convert;
390
391 # pass 2, optimise, and rename
392 for (@todo) {
393 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
394 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
395 rename "$_->[2]~", $_->[2];
396 }
397 };
398 }
399
400 for (@tile) {
401 my ($x, $y, $file) = @$_;
402 my $tile;
403
404 if (0 > aio_load $file, $tile) {
405 die "$path: unable to read tile +$x+$y, aborting.\n";
406 }
407 IO::AIO::aio_unlink $file unless $CACHE;
408 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
409 }
410 } else {
411 # use as-is (either small, use smooth)
412 commit_png $face, $png, $T;
413 }
414
415 aio_unlink $path if $delete;
416 }
417 }
418
419 sub process_arc {
420 while (my $job = $c_arc->get) {
421 my ($dir, $file) = @$job;
422
423 my $arc;
424 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
425
426 my $arc = read_arch "$dir/$file";
427 for my $o (values %$arc) {
428 push @ARC, $o;
429 for (my $m = $o; $m; $m = $m->{more}) {
430 $ARC{$m->{_name}} = $m;
431 }
432
433 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
434
435 my $visibility = delete $o->{visibility};
436 my $magicmap = delete $o->{magicmap};
437
438 # find upper left corner :/
439 # omg, this is sooo broken
440 my ($dx, $dy);
441 for (my $o = $o; $o; $o = $o->{more}) {
442 $dx = $o->{x} if $o->{x} < $dx;
443 $dy = $o->{y} if $o->{y} < $dy;
444 }
445
446 for (my $o = $o; $o; $o = $o->{more}) {
447 my $x = $o->{x} - $dx;
448 my $y = $o->{y} - $dy;
449
450 my $ext = $x|$y ? "+$x+$y" : "";
451
452 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
453
454 $visibility = delete $o->{visibility} if exists $o->{visibility};
455 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
456
457 my $anim = delete $o->{anim};
458
459 if ($anim) {
460 # possibly add $ext to the animation name to avoid
461 # the need to specify archnames for all parts
462 # of a multipart archetype.
463 $o->{animation} = "$o->{_name}";
464 my $facings = 1;
465 my @frames;
466
467 for (@$anim) {
468 if (/^facings\s+(\d+)/) {
469 $facings = $1*1;
470 } elsif (/^blank.x11$|^empty.x11$/) {
471 push @frames, $_;
472 } else {
473 push @frames, "$_$ext";
474 }
475 }
476
477 $ANIMINFO{$o->{animation}} = {
478 facings => $facings,
479 frames => \@frames,
480 };
481 }
482
483 for ($o->{face} || (), @{$anim || []}) {
484 next if /^facings\s/;
485
486 my $face = $_;
487 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
488
489 my $info = $FACEINFO{$face} ||= { };
490 $info->{arc} = $o;
491
492 next if $face =~ /^blank.x11$|^empty.x11$/;
493
494 $info->{visibility} = $visibility if defined $visibility;
495 $info->{magicmap} = $magicmap if defined $magicmap;
496 }
497
498 if (my $smooth = delete $o->{smoothface}) {
499 my %kv = split /\s+/, $smooth;
500 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
501 while (my ($face, $smooth) = each %kv) {
502 $FACEINFO{$smooth}{arc} = $o;
503
504 $FACEINFO{$face}{smooth} = $smooth;
505 $FACEINFO{$face}{smoothlevel} = $level;
506 }
507 }
508 }
509 }
510 }
511 }
512
513 sub process_trs {
514 while (my $job = $c_trs->get) {
515 my ($dir, $file) = @$job;
516 my $path = "$dir/$file";
517
518 my $trs;
519 if (0 > aio_load $path, $trs) {
520 warn "$path: $!, skipping.\n";
521 next;
522 }
523
524 $TRS .= $trs;
525 }
526 }
527
528 my %FILECACHE;
529
530 sub load_cached($;$) {
531 unless (exists $FILECACHE{$_[0]}) {
532 my $data;
533 if (0 < aio_load $_[0], $data) {
534 if ($_[1]) {
535 $data = eval { $_[1]->($data) };
536 warn "$_[0]: $@" if $@;
537 }
538 }
539
540 $FILECACHE{$_[0]} = $data;
541 }
542
543 $FILECACHE{$_[0]}
544 }
545
546 sub process_res {
547 while (my $job = $c_res->get) {
548 my ($dir, $file, $type) = @$job;
549
550 my $data;
551 aio_load "$dir/$file", $data;
552
553 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
554
555 utf8::decode $dir;
556 utf8::decode $file;
557
558 # a meta file for resources is now mandatory
559 unless (exists $meta->{$file}) {
560 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
561 next;
562 }
563
564 $meta = {
565 %{ $meta->{"" } || {} },
566 %{ $meta->{$file} || {} },
567 };
568
569 if ($meta->{license} =~ s/^#//) {
570 $meta->{license} = ({
571 "pd" => "Public Domain",
572 "gpl" => "GNU General Public License, version 3.0 or any later",
573 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
574 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
575 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
576 })->{$meta->{license}}
577 || warn "$dir/$file: license tag '$meta->{license}' not found.";
578 }
579
580 $file =~ s/\.res$//;
581 $file =~ s/\.(ogg|wav|jpg|png)$//;
582
583 substr $dir, 0, 1 + length $PATH, "";
584
585 if (my $filter = $meta->{cfutil_filter}) {
586 if ($filter eq "yaml2json") {
587 $data = JSON::XS::encode_json YAML::XS::Load $data;
588 } elsif ($filter eq "json2json") {
589 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
590 } elsif ($filter eq "perl2json") {
591 $data = eval $data; die if $@;
592 $data = JSON::XS::encode_json $data;
593 } else {
594 warn "$dir/$file: unknown filter $filter, skipping\n";
595 }
596 }
597
598 $RESOURCE{"$dir/$file"} = {
599 type => (exists $meta->{type} ? delete $meta->{type} : $type),
600 data => $data,
601 %$meta ? (meta => $meta) : (),
602 };
603 }
604 }
605
606 sub find_files;
607 sub find_files {
608 my ($path) = @_;
609
610 IO::AIO::aioreq_pri 4;
611 IO::AIO::aio_scandir $path, 4, sub {
612 my ($dirs, $nondirs) = @_;
613
614 find_files "$path/$_"
615 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
616
617 my $dir = $path;
618 substr $dir, 0, 1 + length $PATH, "";
619
620 for my $file (@$nondirs) {
621 if ($dir =~ /^music(?:\/|$)/) {
622 $c_res->put ([$path, $file, 3]) # FT_MUSIC
623 if $file =~ /\.(ogg)$/;
624
625 } elsif ($dir =~ /^sound(?:\/|$)/) {
626 $c_res->put ([$path, $file, 5]) # FT_SOUND
627 if $file =~ /\.(wav|ogg)$/;
628
629 } elsif ($dir =~ /^res(?:\/|$)/) {
630 if ($file =~ /\.(jpg|png)$/) {
631 $c_res->put ([$path, $file, 0]) # FT_FACE
632 } elsif ($file =~ /\.(res)$/) {
633 $c_res->put ([$path, $file, 6]) # FT_RSRC
634 } else {
635 $c_res->put ([$path, $file, undef]);
636 }
637
638 } elsif ($file =~ /\.png$/) {
639 push @c_png, ["$path/$file", 0];
640
641 } elsif ($file =~ /\.trs$/) {
642 $c_trs->put ([$path, $file]);
643
644 } elsif ($file =~ /\.arc$/) {
645 $c_arc->put ([$path, $file]);
646
647 } else {
648 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
649 }
650 }
651 };
652 }
653
654 sub generate_plurals {
655 # use Lingua::EN::Inflect ();
656 # Lingua::EN::Inflect::classical;
657 # Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
658 # Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
659 #
660 # for my $a (@ARC) {
661 # my $name = $a->{name} || $a->{_name};
662 #
663 # next unless $a->{name_pl};
664 # next if $a->{invisible};
665 # next if $a->{is_floor};
666 # next if $a->{no_pick};
667 #
668 # my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
669 # my $pl = $test =~ /^(?:eq|p:.)$/
670 # ? $name
671 # : Lingua::EN::Inflect::PL $name;
672 #
673 # if ($pl ne $a->{name_pl}) {
674 # warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
675 # }
676 # }
677 }
678
679 sub inst_arch($) {
680 my (undef, $path) = @_;
681
682 $PATH = $path;
683
684 print "\n",
685 "Installing '$path' to '$DATADIR'\n",
686 "\n",
687 "This can take a long time if you run this\n",
688 "for the first time or do not use --cache.\n",
689 "\n",
690 "Unless you run verbosely, all following warning\n",
691 "or error messages indicate serious problems.\n",
692 "\n";
693
694 if (!-d "$path/treasures") {
695 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
696 exit 1 unless $FORCE;
697 }
698
699 print "scanning files...\n" if $VERBOSE;
700
701 find_files $path;
702
703 my @a_arc = map +(async \&process_arc), 1..2;
704 my @a_res = map +(async \&process_res), 1..2;
705 my @a_trs = map +(async \&process_trs), 1..2;
706
707 IO::AIO::flush;
708
709 $c_res->shutdown;
710 $c_arc->shutdown;
711 $c_trs->shutdown;
712
713 print "start file scan, arc, res processing...\n" if $VERBOSE;
714
715 $_->join for @a_arc; # need to parse all archetypes before png processing
716
717 print "end arc, start png processing...\n" if $VERBOSE;
718
719 # eight png crunchers work fine for my 4x smp machine
720 my @a_png = map +(async \&process_png), 1..8;
721
722 $_->join for (@a_trs, @a_res, @a_png);
723
724 print "scanning done, processing results...\n" if $VERBOSE;
725 {
726 # remove path prefix from editor_folder
727 $_->{editor_folder} =~ /^\x00/
728 and substr $_->{editor_folder}, 0, 2 + length $path, ""
729 for values %ARC;
730
731 print "resolving inheritance tree...\n" if $VERBOSE;
732 # resolve inherit
733 while () {
734 my $progress;
735 my $loop;
736
737 for my $o (values %ARC) {
738 for my $other (split /,/, $o->{inherit}) {
739 if (my $s = $ARC{$other}) {
740 if ($s->{inherit}) {
741 $loop = $s;
742 } else {
743 delete $o->{inherit};
744 my %s = %$s;
745 delete @s{qw(_name more name name_pl)};
746 %$o = ( %s, %$o );
747 ++$progress;
748 }
749 } else {
750 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
751 delete $ARC{$o->{_name}};
752 }
753 }
754 }
755
756 unless ($progress) {
757 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
758 if $loop;
759
760 last;
761 }
762 }
763
764 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
765 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
766
767 print "generating plurals...\n" if $VERBOSE;
768 generate_plurals;
769
770 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
771 open my $fh, ">:utf8", "$DATADIR/archetypes~"
772 or die "$DATADIR/archetypes~: $!";
773 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
774 }
775
776 {
777 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
778 open my $fh, ">:utf8", "$DATADIR/treasures~"
779 or die "$DATADIR/treasures~: $!";
780 print $fh $TRS;
781 }
782
783 {
784 print "processing facedata...\n" if $VERBOSE;
785 while (my ($k, $v) = each %FACEINFO) {
786 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
787 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
788
789 make_hash $k, $v->{data32}, $v->{hash32};
790 make_hash $k, $v->{data64}, $v->{hash64};
791
792 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
793 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
794
795 if (my $magicmap = $v->{magicmap}) {
796 $magicmap =~ y/A-Z_\-/a-z/d;
797 $v->{magicmap} = $COLOR{$magicmap};
798 }
799
800 delete $v->{arc};
801 }
802
803 print "processing resources...\n" if $VERBOSE;
804 my $enc = JSON::XS->new->utf8->canonical->relaxed;
805 while (my ($k, $v) = each %RESOURCE) {
806
807 if ($v->{type} & 1) {
808 # prepend meta info
809
810 my $meta = $enc->encode ({
811 name => $k,
812 %{ $v->{meta} || {} },
813 });
814
815 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
816 }
817
818 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
819 }
820
821 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
822 scalar keys %FACEINFO,
823 scalar keys %ANIMINFO,
824 scalar keys %RESOURCE
825 if $VERBOSE;
826
827 open my $fh, ">:perlio", "$DATADIR/facedata~"
828 or die "$DATADIR/facedata~: $!";
829
830 print $fh freeze {
831 version => 2,
832 faceinfo => \%FACEINFO,
833 animinfo => \%ANIMINFO,
834 resource => \%RESOURCE,
835 };
836
837 }
838
839 print "committing files...\n" if $VERBOSE;
840
841 for (qw(archetypes facedata treasures)) {
842 chmod 0644, "$DATADIR/$_~";
843 rename "$DATADIR/$_~", "$DATADIR/$_"
844 or die "$DATADIR/$_: $!";
845 }
846
847 print "archetype data installed successfully.\n";
848 }
849 }
850
851 Getopt::Long::Configure ("bundling", "no_ignore_case");
852 GetOptions (
853 "verbose|v:+" => \$VERBOSE,
854 "cache" => \$CACHE,
855 "quiet|q" => sub { $VERBOSE = 0 },
856 "force" => sub { $FORCE = 1 },
857 "install-arch=s" => \&inst_arch,
858 "install-maps=s" => \&inst_maps,
859 "print-statedir" => sub { print "@pkgstatedir@\n" },
860 "print-datadir" => sub { print "$DATADIR\n" },
861 "print-confdir" => sub { print "@pkgconfdir@\n" },
862 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
863 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
864 ) or usage;
865